(define-module (type hostname)
    :use-module (alterator woo)
    :export (hostname-regex hostname?
             type))

(define *hostname-regex-str* "^[0-9_a-zA-Z]((\\.[a-zA-Z0-9_])*[a-zA-Z0-9_-]*)*$")
(define hostname-regex (make-regexp *hostname-regex-str* regexp/extended))

(define (hostname? str)
  (and (string? str)
       (not (string-null? str))
       (regexp-exec hostname-regex str)))

(define (type v _)
  (or (and (string? v) (string-null? v))
      (hostname? v)
      (type-error (_ "A host name should contain only latin letters, digits, '-', '.' and '_' and should start with a letter, a digit or '_'"))))
