(define-module (type ipv4-address-range)
  :use-module (alterator woo)
  :use-module (ice-9 regex)
  :export (ipv4-address-range-regex-str
           ipv4-address-range-regex
           ipv4-address-range?
           type))

(define ipv4-address-range-regex-str "([1-9]?[0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])([.]([1-9]?[0-9]|1[0-9]{2}|2[0-4][0-9+]|25[0-5])){2}([.]([1-9]?[0-9]|1[0-9]{2}|2[0-4][0-9+]|25[0-5]))(-([1-9]?[0-9]|1[0-9]{2}|2[0-4][0-9+]|25[0-5]))?")
(define ipv4-address-range-regex-str2 (string-append "^" ipv4-address-range-regex-str "$"))

(define ipv4-address-range-regex (make-regexp ipv4-address-range-regex-str2 regexp/extended))

(define (ipv4-address-range? v)
  (or (and (string? v) (string-null? v))
      (and (string? v)
           (let ((m (regexp-exec ipv4-address-range-regex v)))
             (and m
                  (or (not (match:substring m 7))
                      (> (string->number (match:substring m 7))
                         (string->number (match:substring m 5)))))))))

(define (type v _)
  (or (ipv4-address-range? v)
      (type-error (_ "invalid IP address range"))))
